#include <stdio.h>
#include <stdlib.h>
#include <SDL.h>
#include <emscripten.h>
#include <emscripten/html5.h>

#include "main.h"
#include "tex.h"

SDL_Surface *d_screen;

SDL_Texture *wallpaper, *ants;
SDL_Window *window;
SDL_Renderer *render;

SDL_AudioSpec *spec;

long long clk = 0;

void audio_callback(void *userdata, Uint8 *stream, int len) {
 int i;
 for(i=0;i<len;i++) {
  stream[i] = random();
 }
}
		  


void soundp_start(void) {
 SDL_AudioSpec des, *got;
 des.freq = 22050;
 des.format = AUDIO_S16LSB;
 des.channels=1;
 des.samples=4096;
 des.callback = audio_callback;

 got = (SDL_AudioSpec *)malloc(sizeof(SDL_AudioSpec));
 if(SDL_OpenAudio(&des,got)<0) {
  fprintf(stderr, "Couldn't open audio: %s\n", SDL_GetError());
  exit(-1);
 }

 spec = got; 
 SDL_PauseAudio(0);
}

void q_input(void) {
 SDL_Event event;

 while(SDL_PollEvent(&event))
  switch(event.type) {
   case SDL_MOUSEBUTTONDOWN:
    printf("mouse down\n");
   break;
   case SDL_FINGERDOWN:
    printf("finger down %d\n", (int)event.tfinger.fingerId);
   break;
   case SDL_FINGERMOTION:
//    printf("finger motion\n");
   break; 
  }
	
}


EM_BOOL looper(double time, void *userData) {
 int i;
 SDL_Rect rec;
 SDL_Point point;
 q_input();
 SDL_RenderCopy(render, wallpaper, NULL,NULL);
 rec.x = (320-50)+(clk%200);
 rec.y = 240-50;
 rec.w = 100;
 rec.h = 100;
 SDL_RenderCopy(render, ants, NULL ,&rec);
 SDL_UpdateWindowSurface(window);
 clk+=5;
 return EM_TRUE;
}


int main(void) {
 SDL_Init(SDL_INIT_EVERYTHING);
 window = SDL_CreateWindow("bloody rad",
		SDL_WINDOWPOS_UNDEFINED,
		SDL_WINDOWPOS_UNDEFINED,
		640,480, 0);
 render = SDL_CreateSoftwareRenderer(SDL_GetWindowSurface(window));
 wallpaper=load_tex("c_img/back.bmp");
 ants=load_tex("c_img/ants.bmp");
 soundp_start();
 emscripten_request_animation_frame_loop(looper, (void *)0);
// emscripten_set_main_loop(looper, 0, 1);
 return 0;
}
